<?php
/**
 * @copyright CometChat
 * @author support@cometchat.com
 */

// make sure we are not being called directly
defined('APP_DIR') or exit();

function view_ccCometChat_admin_panel($_post, $_user, $_conf)
{
    jrUser_session_require_login();
    jrUser_master_only();
//    jrCore_page_include_admin_menu();
    jrCore_page_admin_tabs('ccCometChat', 'admin_panel');
    jrCore_page_banner('CometChat Administration Panel');

    if ($_conf['ccCometChat_baseurl'] != '') {
        $baseurl = $_conf['ccCometChat_baseurl'];
    }
    else {
        $baseurl = 'modules/ccCometChat/contrib/cometchat';
    }
    $adminpanel = $_conf['jrCore_base_url'] . '/modules/ccCometChat/contrib/cometchat/admin/index.php';
    $html = <<<EOD
    <script language="JavaScript">
    function autoResize(id){
        var newheight;
        var newwidth;

        if(document.getElementById){
            document.getElementById(id).contentWindow.document.getElementsByTagName('html')[0].style.zoom = '95%';
            document.getElementById(id).contentWindow.document.getElementsByTagName('html')[0].style.overflowY = 'hidden';
            newheight = document.getElementById(id).contentWindow.document.body.scrollHeight;
            newwidth = document.getElementById(id).contentWindow.document.body.scrollWidth;
        }
        document.getElementById(id).height = (newheight) + "px";
        document.getElementById(id).width = (newwidth) + "px";
    }
    </script>
    <iframe id='iframe1' src="{$adminpanel}" width="1115" height="700" onLoad="autoResize('iframe1');"></iframe>
EOD;
    jrCore_page_custom($html);
    jrCore_page_display();
}

function view_ccCometChat_admin_install($_post, $_user, $_conf)
{
    jrUser_session_require_login();
    jrUser_master_only();
    jrCore_page_include_admin_menu();
    jrCore_page_admin_tabs('ccCometChat', 'admin_install');
    jrCore_page_banner('Install CometChat');

    jrCore_page_custom('<p>Click below to install CometChat. Set the correct base url in <a href="admin/global">Global Config</a>.<br /><span style="color:red">All messages in the previous CometChat installation will be inaccessible.</span></p>');

    $_tmp = array(
        'submit_value' => 'Install CometChat',
        'cancel'       => 'referrer'
    );
    jrCore_form_create($_tmp);
    jrCore_page_display();
}

function view_ccCometChat_admin_install_save($_post, $_user, $_conf)
{
    jrUser_session_require_login();

    $baseurl = $_conf['jrCore_base_dir'] . '/modules/ccCometChat/contrib/cometchat';

    if (file_exists($baseurl . '/install.php')) {
        ob_start();
        include($baseurl . '/install.php');
    } else {
        $extra = "We could not find CometChat at &lt;JAMROOM_ROOT&gt; directory. CometChat should be placed in <JAMRROM_ROOT> during installation.";
        jrCore_set_form_notice('error', $extra);
        jrCore_form_result();
    }
    $includedphp = ob_get_contents();
    ob_end_clean();

    //Set the correct base url correctly in config.php
    $base    = $_conf['jrCore_base_url'] . '/' . 'modules/ccCometChat/contrib/cometchat' . '/';
    $file    = $_conf['jrCore_base_dir'] . '/' . 'modules/ccCometChat/contrib/cometchat' . '/config.php';
    $content = @file_get_contents($file);

    if ($content != '') {

        $myvar = "define('BASE_URL','{$base}');";

        $pattern = "/\/\* BASE URL START \*\/(\s*)(.*?)(\s*)\/\* BASE URL END \*\//is";

        $replacement = "/* BASE URL START */\r\n\r\n" . $myvar . "\r\n\r\n/* BASE URL END */";

        $content = preg_replace($pattern, $replacement, $content);

        $f = @fopen($file, 'w');
        if ($f) {
            @fwrite($f, $content);
            @fclose($f);
        }
    }else{
        jrCore_set_form_notice('error', "CometChat is successfully installed but we could not set CometChat base url correctly.");
        jrCore_form_result();
    }
    if ($handle = opendir($_conf['jrCore_base_dir'] . '/' . $baseUrl . '/cache/')) {
        while (false !== ($file = readdir($handle))) {
            if ($file != "." && $file != ".." && $file != "index.html") {
                @unlink($_conf['jrCore_base_dir'] . '/' . $baseUrl . '/cache/' . $file);
            }
        }
    }

    jrCore_set_form_notice('success', 'CometChat Installed Successfully');
    jrCore_form_result();
}